#!/usr/bin/env python
"""AppWindow.py:
This module provides an application window --
a GtkWindow that knows when to quit."""

import gtk

class AppWindow(gtk.GtkWindow):
    """This is just a GtkWindow which exits its event loop when destroyed."""
    def __init__(self, title=None):
        """Initialize a new instance.
        If specified, `title' will be displayed in the window's title bar."""
        gtk.GtkWindow.__init__(self)
        if title:
            self.set_title(title)

        self.connect("delete_event", self.quit)

    def quit(self, *args):
        """Exit the application -- or at least exit its event loop."""
        gtk.mainquit()


def main():
    """Module mainline (for standalone execution)"""
    win = AppWindow(title="Sample App Window")
    label = gtk.GtkLabel("Hello, world.")
    win.add(label)
    label.show()
    win.show()
    gtk.mainloop()


if __name__ == "__main__":
    main()
